#include "loadbitmap.h"
#include <gui/font.h>
#include <gui/desktop.h>
#include <libnet/datafactory.h>
#include <libnet/url.h>
#include <storage/seekableio.h>

#include <stdio.h>

BitmapImage* LoadImageFromFile(const os::String& cString)
{
	net::Url cUrl(cString);
	net::Datafactory cFactory;
	os::BitmapImage * pcImage = new os::BitmapImage();
	os::SeekableIO *pcStream = cFactory.CreateStream(cUrl);
	printf("Loading %s..\n", cUrl.GetUrl().c_str());
	pcImage->Load(pcStream);
	delete pcStream;
	return pcImage;
}

/************************************************
* Description: Loads a bitmapimage from resource
* Author: Rick Caudill
* Date: Thu Mar 18 21:32:37 2004
*************************************************/
os::BitmapImage* LoadImageFromResource( const os::String &cName )
{
	os::BitmapImage * pcImage = new os::BitmapImage();
	os::Resources cRes( get_image_id() );
	os::ResStream * pcStream = cRes.GetResourceStream( cName.c_str() );
	if( pcStream == NULL )
	{
		throw( os::errno_exception("") );
	}
	pcImage->Load( pcStream );
	return pcImage;
}
