#include <libnet/url.h>
#include <libnet/datafactory.h>
#include <storage/seekableio.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>

using namespace net;

int main( int argc, char *argv[] )
{
	Url cUrl("http://www.liqwyd.com:80/index.shtml");
	Url cUrl2("file:///atheos/Documentation/net/index.html");
	Datafactory cFactory;
	os::SeekableIO *pcStream;
	uint8 pzBuffer[1025];

	// Get a remote file
	pcStream = cFactory.CreateStream( cUrl );
	if( pcStream == NULL )
	{
		std::cerr << "pcStream is NULL for " << cUrl.GetUrl().str() << std::endl;
		return EXIT_FAILURE;
	}

	memset( pzBuffer, 0, 1025 );
	std::cerr << pcStream->Read(pzBuffer,1024) << " bytes read." << std::endl;
	std::cout << pzBuffer << std::endl;
	delete pcStream;

	// Get a local file
	pcStream = cFactory.CreateStream( cUrl2 );
	if( pcStream == NULL )
	{
		std::cerr << "pcStream is NULL for " << cUrl2.GetUrl().str() << std::endl;
		return EXIT_FAILURE;
	}

	memset( pzBuffer, 0, 1025 );
	std::cerr << pcStream->Read(pzBuffer,1024) << " bytes read." << std::endl;
	std::cout << pzBuffer << std::endl;
	delete pcStream;

	return EXIT_SUCCESS;
}

