#include <libnet/socket.h>
#include <libnet/host.h>
#include <libnet/url.h>
#include <iostream>
#include <stdlib.h>
#include <error.h>

using namespace net;

int main( int argc, char *argv[] )
{
	Url cUrl1("http://www.syllable.org:80");
	Host cHost1(cUrl1);
	Socket cSocket1( cHost1 );
	char zMsg[] = "GET /\r\n";
	char zBuffer[128];

	memset(zBuffer,0,128);

	std::cout << "1: Connect() returns " << (cSocket1.Connect()==0?"O.K":"error") << std::endl;
	std::cout << "2: IsConnected() returns " << (cSocket1.IsConnected()==true?"connected":"not connected") << std::endl;
	// Attempt a simple HTTP transfer
	std::cout << "3: Send() \"" << zMsg << "\" returns " << cSocket1.Send((void*)zMsg, 7)  << " bytes sent" << std::endl;
	std::cout << "4: Recieve() of 128 bytes returns " << cSocket1.Recieve((void*)zBuffer, 128) << " bytes received" << std::endl;
	std::cout << "Recieve() data follows:" << std::endl;
	std::cout << "-----------------------" << std::endl << zBuffer << std::endl << "-----------------------" << std::endl;
	// Disconnect
	cSocket1.Disconnect();
	std::cout << "5: IsConnected() returns " << (cSocket1.IsConnected()==true?"connected":"not connected") << std::endl;

	// Try a mail server
	Host cHost2("mail.liqwyd.com",110);
	Socket cSocket2( cHost2 );
#if 0
	memset(zBuffer,0,128);

	std::cout << "6: Connect() returns " << (cSocket2.Connect()==0?"O.K":"error") << std::endl;
	std::cout << "7: ReadLine() returns " << cSocket2.ReadLine( (uint8*)zBuffer, 128 ) << " bytes read" << std::endl;
	std::cout << "ReadLine() data follows:" << std::endl;
	std::cout << "-----------------------" << std::endl << zBuffer << std::endl << "-----------------------" << std::endl;
	cSocket2.Disconnect();
#else
	memset(zBuffer,0,128);

	std::cout << "8: Connect() returns " << (cSocket2.Connect()==0?"O.K":"error") << std::endl;
	std::cout << "9: WaitFor() returns " << cSocket2.WaitFor("POP3", (uint8*)zBuffer, 128 ) << " bytes read" << std::endl;
	std::cout << "WaitFor() data follows:" << std::endl;
	std::cout << "-----------------------" << std::endl << zBuffer << std::endl << "-----------------------" << std::endl;
	cSocket2.Disconnect();
#endif
	return EXIT_SUCCESS;
}
